diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
index 21b47a2e2..74d3cf598 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
@@ -34,10 +34,10 @@ public class ScreenMobPicker
     @Override
     public void init() {
         List<NamespaceID> monsters = new ArrayList<>();
-        for (Class<? extends Entity> clazz : EntityDispatcher.classToIdMap.keySet()) {
-            if (clazz == MobFireflyCluster.class) continue;
-            if (Mob.class.isAssignableFrom(clazz) && !Modifier.isAbstract(clazz.getModifiers())) {
-                monsters.add(EntityDispatcher.classToIdMap.get(clazz));
+        for (EntityDispatcher.EntityDispatcherEntry<?> entry : EntityDispatcher.getInstance().entries) {
+            if (entry.entityClass == MobFireflyCluster.class) continue;
+            if (Mob.class.isAssignableFrom(entry.entityClass) && !Modifier.isAbstract(entry.entityClass.getModifiers())) {
+                monsters.add(entry.namespaceID);
             }
         }
         Collections.sort(monsters);
@@ -68,7 +68,7 @@ public class ScreenMobPicker
                         }
                         spawner.setMobId(mobId);
                     } else {
-                        mc.getSendQueue().addToSendQueue(new PacketSetMobSpawner(x, y, z, EntityDispatcher.classForId(mobId)));
+                        mc.getSendQueue().addToSendQueue(new PacketSetMobSpawner(x, y, z, EntityDispatcher.getInstance().entryForId(mobId)));
                     }
                 }
                 shouldClose = true;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
index e4b9000c0..1a55fed5e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.gui;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -11,16 +12,21 @@ import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.client.player.controller.PlayerControllerSP;
 import net.minecraft.core.world.save.LevelData;
+import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveFile;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 
 import java.text.DateFormat;
 import java.text.SimpleDateFormat;
 import java.util.Collections;
 import java.util.Date;
+import java.util.HashMap;
 import java.util.List;
+import java.util.Map;
 
 public class ScreenSelectWorld extends Screen
 {
@@ -29,6 +35,7 @@ public class ScreenSelectWorld extends Screen
     private boolean selected;
     private int selectedWorld;
     private List<SaveFile> saveList;
+    private Map<SaveFile, @Nullable CompoundTag> userTags;
     private WorldSlot worldSlotContainer;
     private String stringWorld;
     private String stringConversion;
@@ -81,8 +88,18 @@ public class ScreenSelectWorld extends Screen
 
     private void loadSaves()
     {
-        ISaveFormat isaveformat = mc.getSaveFormat();
-        saveList = isaveformat.getSaveFileList();
+        ISaveFormat saveFormat = mc.getSaveFormat();
+        saveList = saveFormat.getSaveFileList();
+        userTags = new HashMap<>();
+        for (SaveFile file : saveList) {
+            LevelStorage levelStorage = saveFormat.getSaveHandler(file.getFileName(), false);
+            LevelData data = levelStorage.getLevelData();
+            if (data != null && data.getLastPlayerUUID() != null) {
+                userTags.put(file, levelStorage.getPlayerData(null, data.getLastPlayerUUID()));
+            } else {
+                userTags.put(file, levelStorage.getPlayerData(mc.session.username, mc.session.uuid));
+            }
+        }
         Collections.sort(saveList);
         if (selectedWorld >= saveList.size())
         {
@@ -98,7 +115,7 @@ public class ScreenSelectWorld extends Screen
     protected String getSaveName(int i)
     {
         String s = saveList.get(i).getDisplayName();
-        if(s == null || MathHelper.stringNullOrLengthZero(s))
+        if(MathHelper.stringNullOrLengthZero(s))
         {
             I18n i18n = I18n.getInstance();
             s = i18n.translateKeyAndFormat(stringWorld, i + 1);
@@ -166,25 +183,19 @@ public class ScreenSelectWorld extends Screen
     @Override
     protected void buttonClicked(ButtonElement button)
     {
-        if(!button.enabled)
-        {
+        if(!button.enabled) {
             return;
         }
-        if(button.id == 2)
-        {
+        if(button.id == 2) {
             tryDeleteWorld(false);
         }
-        else if(button.id == 1)
-        {
+        else if(button.id == 1) {
             selectWorld(selectedWorld);
         }
-        else if(button.id == 3)
-        {
+        else if(button.id == 3) {
             mc.displayScreen(new ScreenCreateWorld(this));
         }
-        else if(button.id == 6)
-        {
-            I18n i18n = I18n.getInstance();
+        else if(button.id == 6) {
             PopupScreen popup = new PopupBuilder(this, 140)
                     .closeOnEsc(0)
                     .closeOnEnter(1)
@@ -231,7 +242,7 @@ public class ScreenSelectWorld extends Screen
         {
             s = "World" + i;
         }
-        mc.startWorld(s, getSaveName(i), 0L);
+        mc.startWorld(s);
         mc.displayScreen(null);
     }
 
@@ -262,8 +273,10 @@ public class ScreenSelectWorld extends Screen
 
     class WorldSlot extends ScrolledSelectionList
     {
-        public WorldSlot()
-        {
+        private final @NotNull StringBuilder nameBuilder = new StringBuilder();
+        private final @NotNull StringBuilder descBuilder1 = new StringBuilder();
+        private final @NotNull StringBuilder descBuilder2 = new StringBuilder();
+        public WorldSlot() {
             super(mc, width, height, 32, height - 64, 36);
         }
 
@@ -307,24 +320,39 @@ public class ScreenSelectWorld extends Screen
         }
 
         @Override
-        protected void renderItem(int index, int x, int y, int height, Tessellator tessellator)
+        protected void renderItem(int index, int x, int y, int height, @NotNull Tessellator t)
         {
+            nameBuilder.setLength(0);
+            descBuilder1.setLength(0);
+            descBuilder2.setLength(0);
+
             I18n i18n = I18n.getInstance();
             SaveFile saveFile = saveList.get(index);
-            String s = saveFile.getDisplayName();
-            if (saveFile.isCorrupted()) s = TextFormatting.RED + s;
-            if(s == null || MathHelper.stringNullOrLengthZero(s))
-            {
-                s = i18n.translateKeyAndFormat(stringWorld, index + 1);
+
+            CompoundTag userTag = userTags.get(saveFile);
+            Gamemode gamemode;
+            if (userTag != null) {
+                gamemode = Gamemode.gamemodesList[userTag.getInteger("Gamemode")];
+            } else {
+                gamemode = Gamemode.survival;
             }
-            String s1 = saveFile.getFileName();
-            s1 = s1 + " (" + dateFormatter.format(new Date(saveFile.getLastTimePlayed()));
-            long l1 = saveFile.getSizeOnDisk();
-            s1 = s1 + ", " + (float) (((l1 / 1024L) * 100L) / 1024L) / 100F + " MB)";
-            String s2 = "";
+
+            final String saveName = saveFile.getDisplayName();
+            if (saveFile.isCorrupted()) nameBuilder.append(TextFormatting.RED);
+            if(MathHelper.stringNullOrLengthZero(saveName)) {
+                nameBuilder.append(i18n.translateKeyAndFormat(stringWorld, index + 1));
+            } else {
+                nameBuilder.append(saveName);
+            }
+
+            long sizeBytes = saveFile.getSizeOnDisk();
+            descBuilder1.append(saveFile.getFileName());
+            descBuilder1.append(" (").append(dateFormatter.format(new Date(saveFile.getLastTimePlayed())));
+            descBuilder1.append(", ").append((float) (((sizeBytes / 1024L) * 100L) / 1024L) / 100F).append(" MB)");
+
             if(saveFile.getNeedsConversion())
             {
-                s2 = stringConversion + " " + s2;
+                descBuilder2.append(stringConversion).append(" ");
             }
             else
             {
@@ -332,22 +360,22 @@ public class ScreenSelectWorld extends Screen
                 LevelData ld = saveFile.getLevelData();
                 DimensionData dd = saveFile.getDimensionData().get(0);
                 if (dd == null){
-                    s2 += TextFormatting.RED + st.translateKey("gui.select_world.label.dimension_corrupted");
+                    descBuilder2.append(TextFormatting.RED).append(st.translateKey("gui.select_world.label.dimension_corrupted"));
                 } else {
-                    s2 += st.translateKey(Gamemode.gamemodesList[ld.getGamemode()].getLanguageKey() + ".name");
-                    if (ld.getCheatsEnabled()) s2 += " | " + st.translateKey("gui.select_world.label.cheats");
+                    descBuilder2.append(st.translateKey(gamemode.getLanguageKey() + ".name"));
+                    if (ld != null && ld.getCheatsEnabled()) descBuilder2.append(" | ").append(st.translateKey("gui.select_world.label.cheats"));
                     WorldType worldType = dd.getWorldType();
                     if (worldType != null) {
-                        s2 += " | " + st.translateKey(dd.getWorldType().getLanguageKey() + ".name");
+                        descBuilder2.append(" | ").append(st.translateKey(dd.getWorldType().getLanguageKey() + ".name"));
                     } else {
-                        s2 += " | " + TextFormatting.RED + st.translateKey("gui.select_world.label.unknown");
+                        descBuilder2.append(" | ").append(TextFormatting.RED).append(st.translateKey("gui.select_world.label.unknown"));
                     }
                 }
             }
 
-            drawStringShadow(fontRenderer, s, x + 2, y + 1, 0xffffff);
-            drawStringShadow(fontRenderer, s1, x + 2, y + 12, 0x808080);
-            drawStringShadow(fontRenderer, s2, x + 2, y + 12 + 10, 0x808080);
+            drawStringShadow(fontRenderer, nameBuilder, x + 2, y + 1, 0xffffff);
+            drawStringShadow(fontRenderer, descBuilder1, x + 2, y + 12, 0x808080);
+            drawStringShadow(fontRenderer, descBuilder2, x + 2, y + 12 + 10, 0x808080);
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
index d79342dfc..a39fa5a99 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
@@ -29,9 +29,9 @@ public class ScreenWandMobPicker extends Screen {
     @Override
     public void init() {
         List<NamespaceID> monsters = new ArrayList<>();
-        for (Class<? extends Entity> clazz : EntityDispatcher.classToIdMap.keySet()) {
-            if (Mob.class.isAssignableFrom(clazz) && !Modifier.isAbstract(clazz.getModifiers())) {
-                monsters.add(EntityDispatcher.classToIdMap.get(clazz));
+        for (EntityDispatcher.EntityDispatcherEntry<?> entry : EntityDispatcher.getInstance().entries) {
+            if (Mob.class.isAssignableFrom(entry.entityClass) && !Modifier.isAbstract(entry.entityClass.getModifiers())) {
+                monsters.add(entry.namespaceID);
             }
         }
         Collections.sort(monsters);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
index 3a866bc28..eaf4fcf2f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
@@ -551,9 +551,9 @@ public class ScreenGuidebook
             int fgColor = section.getForegroundColor();
             ItemStack icon = section.getTabIcon();
 
-            OpenGLHelper.glColor1i(bgColor);
+            OpenGLHelper.glColor1i(0xFF000000 | bgColor);
             drawTexturedModalRect(x + xo, y, u, v, WIDTH, HEIGHT);
-            OpenGLHelper.glColor1i(fgColor);
+            OpenGLHelper.glColor1i(0xFF000000 | fgColor);
             drawTexturedModalRect(x + xo, y, u, v + HEIGHT, WIDTH, HEIGHT);
 
             if (icon != null) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
index 892b461cc..0aeff3f7c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
@@ -45,14 +45,14 @@ public class GuidebookPageMob
 
 
 
-    public GuidebookPageMob(GuidebookSection section, Class<? extends Entity> mobClass, MobInfoRegistry.MobInfo mobInfo) {
+    public GuidebookPageMob(GuidebookSection section, Class<? extends Mob> mobClass, MobInfoRegistry.MobInfo mobInfo) {
         super(section);
 
         this.mobClass = mobClass;
         this.mobInfo = mobInfo;
         Mob example = null;
         try {
-            example = (Mob) mobClass.getConstructor(World.class).newInstance(WorldClient.EMPTY_WORLD);
+            example = EntityDispatcher.getInstance().createEntityInWorld(mobClass, WorldClient.EMPTY_WORLD);
         } catch (Exception e) {
             LOGGER.error("Failed to create example instance of mob '{}'!", mobClass.getSimpleName(), e);
         }
@@ -70,7 +70,8 @@ public class GuidebookPageMob
             }
         }
 
-        discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(EntityDispatcher.idForClass(mobClass))) > 0;
+        EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(mobClass);
+        discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(entry != null ? entry.namespaceID : null)) > 0;
     }
 
     private static String[] createDescLines(FontRenderer sr, String languageKey) {
@@ -109,7 +110,8 @@ public class GuidebookPageMob
 
     @Override
     protected void renderForeground(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) {
-        discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(EntityDispatcher.idForClass(mobClass))) > 0;
+        EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(mobClass);
+        discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(entry != null ? entry.namespaceID : null)) > 0;
         if (mc.thePlayer.getGamemode() == Gamemode.creative || !mc.gameSettings.hideUndiscoveredItems.value) discovered = true;
 
         Lighting.disable();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookSectionMob.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookSectionMob.java
index 544ce699a..75bb57e40 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookSectionMob.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookSectionMob.java
@@ -8,6 +8,7 @@ import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
@@ -26,7 +27,7 @@ public class GuidebookSectionMob
     public GuidebookSectionMob() {
         super("guidebook.section.mob", new ItemStack(Items.BONE), 0x66962B, 0xC29B1C);
 
-        for (Class<? extends Entity> e : MobInfoRegistry.getMobClassList()) {
+        for (Class<? extends Mob> e : MobInfoRegistry.getMobClassList()) {
             MobInfoRegistry.MobInfo mobInfo = MobInfoRegistry.getMobInfo(e);
             GuidebookPageMob page = new GuidebookPageMob(this, e, mobInfo);
             pages.add(page);
@@ -48,7 +49,7 @@ public class GuidebookSectionMob
     public List<GuidebookPage> searchPages(SearchQuery query) {
         ArrayList<GuidebookPage> filtered = new ArrayList<>();
         if(filteredPages == null || !Objects.equals(filteredPages.getLeft(), query.rawQuery)) {
-            for (Class<? extends Entity> e : MobInfoRegistry.getMobClassList()) {
+            for (Class<? extends Mob> e : MobInfoRegistry.getMobClassList()) {
                 MobInfoRegistry.MobInfo mobInfo = MobInfoRegistry.getMobInfo(e);
                 if(query.strict){
                     if (!I18n.getInstance().translateKey(mobInfo.getNameTranslationKey()).equalsIgnoreCase(query.query.getRight())){
@@ -88,7 +89,8 @@ public class GuidebookSectionMob
         @Override
         public String getName() {
         	Minecraft mc = Minecraft.getMinecraft();
-            boolean discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(EntityDispatcher.idForClass(mobInfo.getEntityClass()))) > 0;
+            EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(mobInfo.getEntityClass());
+            boolean discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(entry != null ? entry.namespaceID : null)) > 0;
             if (mc.thePlayer.getGamemode() == Gamemode.creative) discovered = true;
 
             if (discovered) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
index 014b8c692..5a3d58c88 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.entity.EntityRenderer;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.*;
 import net.minecraft.core.entity.monster.*;
 import net.minecraft.core.item.Items;
@@ -12,15 +13,15 @@ import net.minecraft.core.item.ItemStack;
 import java.util.*;
 
 public abstract class MobInfoRegistry {
-    private static final Map<Class<? extends Entity>, MobInfo> mobInfoMap = new HashMap<>();
-    private static final List<Class<? extends Entity>> mobClassList = new ArrayList<>();
+    private static final Map<Class<? extends Mob>, MobInfo> mobInfoMap = new HashMap<>();
+    private static final List<Class<? extends Mob>> mobClassList = new ArrayList<>();
 
-    public static void register(Class<? extends Entity> entityClass, String nameTranslationKey, String descriptionTranslationKey, int health, int score, MobDrop[] drops) {
+    public static void register(Class<? extends Mob> entityClass, String nameTranslationKey, String descriptionTranslationKey, int health, int score, MobDrop[] drops) {
         mobClassList.add(entityClass);
         mobInfoMap.put(entityClass, new MobInfo(entityClass, nameTranslationKey, descriptionTranslationKey, health, score, drops));
     }
 
-    public static List<Class<? extends Entity>> getMobClassList() {
+    public static List<Class<? extends Mob>> getMobClassList() {
         return Collections.unmodifiableList(mobClassList);
     }
 
